/* Tataroiu Bogdan-Cristian */

#include <stdio.h>
#include <string.h>
#include <assert.h>

#define MAXN 1000000000
#define MAXK 20
#define MAXT 20
#define MOD 666013

#define cnt(i, j, k) cnt[(i) & 1][j][k]

int main() {
    assert(freopen("ikebana.in", "rt", stdin));
    assert(freopen("ikebana.out", "wt", stdout));

    int N, K, T;
    assert(scanf("%d %d %d", &N, &K, &T) == 3);
    assert(1 <= N && N <= MAXN);
    assert(3 <= K && K <= MAXK);
    assert(4 <= T && T <= MAXT);
    /*
     * cnt[i][j][k] = numarul de aranjamente de lungime i, cu ultima gherbere
     * plasata acum j pozitii si ultima planta plasata de tipul k
     *     k == 0 pentru azalee sau orhidee
     *     k == 1 pentru hortensie
     *     k == 2 pentru gherbere
     *     k == 3 pentru celelalte tipuri de plante
     */
    int cnt[2][MAXK + 1][4];
    memset(cnt, 0, sizeof(cnt));
    cnt(1, K, 0) = 2;
    cnt(1, K, 1) = 0;
    cnt(1, 0, 2) = 1;
    cnt(1, K, 3) = (T - 4);
    int i, j, k;
    for (i = 2; i <= N; i++) {
        memset(cnt[i & 1], 0, sizeof(cnt[i & 1]));
        for (j = 1; j <= K; j++) {
            cnt(i, j, 0) += (cnt(i - 1, j - 1, 0) + cnt(i - 1, j - 1, 3)) * 2 + \
                            cnt(i - 1, j - 1, 1);
            cnt(i, j, 1) += cnt(i - 1, j - 1, 0);
            cnt(i, j, 3) += (cnt(i - 1, j - 1, 0) + cnt(i - 1, j - 1, 3)) * (T - 4);
        }

        /* cnt(i, 1, ?) += cnt(i - 1, 0, 2) */
        cnt(i, 1, 0) += cnt(i - 1, 0, 2) * 2;
        cnt(i, 1, 3) += cnt(i - 1, 0, 2) * (T - 4);

        /* cnt(i, K, ?) += cnt(i - 1, K, ?) */
        cnt(i, K, 0) += (cnt(i - 1, K, 0) + cnt(i - 1, K, 3)) * 2 + cnt(i - 1, K, 1);
        cnt(i, K, 1) += cnt(i - 1, K, 0);
        cnt(i, 0, 2) += (cnt(i - 1, K, 0) + cnt(i - 1, K, 3));
        cnt(i, K, 3) += (cnt(i - 1, K, 0) + cnt(i - 1, K, 3)) * (T - 4);

        for (j = 0; j <= K; j++) {
            for (k = 0; k < 4; k++) {
                cnt(i, j, k) %= MOD;
            }
        }
    }

    int SUM = 0;
    /* Sum of cnt(N, j, k), 0 <= j <= J, k in {0, 2, 3} */
    for (j = 0; j <= K; j++) {
        for (k = 0; k < 4; k++) {
            if (k == 1) {
                continue;
            }
            SUM += cnt(N, j, k);
            if (SUM >= MOD) {
                SUM -= MOD;
            }
        }
    }
    printf("%d\n", SUM);

    return 0;
}
